;-- http://radiohlam.ru -  ,   
;--  RC- 9,6 , -  : SPIEN, SUT0  CKSEL0 (  ,      )
.device ATtiny13
.include "tn13def.inc"
.list
;--   
.def   w=r16		;    
.def   Flags=r17    ;   -   ,  0-  -   AN1990,  1-  -   DS2502
.def   Counter=r18	;    

.def   C_2502=r19	;      500 
.def   T_2502=r20	;      500 
.def   C_1990=r21	;      104 
.def   T_1990=r22	;      104 

;--------------------------
.equ   CtrlOut=0	; PB0 -    
.equ   InCode1=3	; PB3 - ,   
.equ   InCode2=4	; PB4 - ,   
.equ   InStart=2	; PB2 - ,   

;--  
; SPL -   
; ACSR -  
; DDRB -   
; PORTB -  
; GIMSK -     
; PCMSK -      
; TCCR0B -  
; TIMSK0 -   
; TCNT0 -  
; OCR0A -   
; TIFR0 -    
;--   
      .cseg
      .org 0
      rjmp Init				;    
;--  
      reti					; INT0
      rjmp PinChange		; Pin Change
      rjmp TimerOverflow	; Timer
      reti					; EEPROM
      reti					; comparator
      reti					; timer compare match A
      reti					; timer compare match B
      reti					; watchdog
      reti					; ADC
;--  
Init: ldi w,RAMEND				;   
      out SPL,w					;     RAM
      sbi ACSR,7				;  
	  clr w
	  out DDRB,w				;     
	  out PORTB,w				;    -  ( )
	  clr Flags					;   
;--     InStart
      ldi w,1<<InStart			;  ,     
      out PCMSK,w
      ldi w,1<<PCIE				;   PinChange
	  out GIMSK,w
;--   (      )
      clr w
      out TCCR0A,w		;  OCR0A, OCR0B , Normal Mode
      ldi w, 1<<TOIE0	;   
	  out TIMSK0,w
;--     EEPROM
EEPROM_read:
	  sbic EECR,EEPE
	  rjmp EEPROM_read	; ,  EEPE  (   )
	  clr  w			;   w  
	  out EEARL,w
	  sbi EECR,EERE		;     EERE
	  in  C_2502,EEDR	;   
	  inc w
	  out EEARL,w
	  sbi EECR,EERE		;     EERE
	  in  T_2502,EEDR	;   
	  inc w
	  out EEARL,w
	  sbi EECR,EERE		;     EERE
	  in  C_1990,EEDR	;   
	  inc w
	  out EEARL,w
	  sbi EECR,EERE		;     EERE
	  in  T_1990,EEDR	;   
;--  
      sei
;--  
Work: rjmp Work

;----------------------------------------------------------------------
;----------------------------------------------------------------------
;--- Interrupts ---
PinChange:
;-- ,    
	  clr w
	  cpse Flags,w		;   Flags  -    (  )
	  reti
;--    PB2 (InStart),    -  
	  sbic	PINB,InStart
	  reti
;--    InCode1, InCode2        
	  in w, PINB		;    
	  andi w,0b00011000	;   PB3, PB4
;-- PB3=0, PB4=1 -  DS2502 (  480-5000 )
;-- PB3=1, PB4=1 -  AN1990 (  >100 )
	  cpi w,0b00011000	; PB3=1, PB4=1
	  breq AN1990_Init
	  cpi w,0b00010000	; PB3=0, PB4=1
	  breq DS2502_Init
	  reti
AN1990_Init:
      out TCNT0,T_1990				;    
	  mov Counter,C_1990 			;    
	  sbr Flags,1					;  ,     AN1990 (0- =1)
	  rjmp TimerStart
DS2502_Init:
      out TCNT0,T_2502				;    
	  mov Counter,C_2502		 	;   
	  sbr Flags,2					;  ,     DS2502 (1- =1)
TimerStart:
;--  PB0   (    )
	  sbi DDRB, CtrlOut
;--  
      ldi w,0b00000100	;  , Normal Mode, /256
      out TCCR0B,w
	  reti                  ; 

;---    -  ,    
TimerOverflow:
	  inc Counter
      breq StopAlg
	  sbrc Flags,0
	  rjmp AN1990_Work
	  sbrc Flags,1
	  rjmp DS2502_Work
StopAlg:
	  clr Flags;		;  
	  out TCCR0B,Flags	;  
	  ;--  PB0   (    )
	  cbi DDRB, CtrlOut				;    (   )
	  reti
AN1990_work:
      out TCNT0,T_1990				;    
	  reti
DS2502_Work:
      out TCNT0,T_2502				;    
	  reti

;--------- EPROM ----------
.eseg
.db 0xFF	; CounterDS2502 -       = 256-255=1 (    ,  508 )
.db 0xED	; TimerDS2502 -    = 256-237 = 19 (  1   508 )
.db 0xE7	; CounterAN1990 -       = 256-231=25 (  25- ,  104 )
.db 0x64	; TimerAN1990 -    = 256-100 = 156 (  1   4161 )
